package com.jxtech.jxudp.platform.web.util;

import com.jxtech.jxudp.crypto.CipherTool;
import com.jxtech.jxudp.platform.cache.JxudpCacheConfig;
import com.jxtech.jxudp.platform.config.JxudpProperties.EncriptType;
import com.jxtech.jxudp.platform.config.JxudpProperties.SpringSecurity;
import com.jxtech.jxudp.platform.workflow.WorkflowUser;
import java.security.KeyFactory;
import java.security.KeyPair;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.X509EncodedKeySpec;
import java.util.Base64;
import javax.crypto.Cipher;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.authentication.AuthenticationServiceException;

public final class SecurityUtil {

   private static KeyPair keyPair = null;
   private static final Logger log = LoggerFactory.getLogger(SecurityUtil.class);


   public static String decryptRsa(String str, SpringSecurity springSecurity) throws Exception {
      byte[] a = Base64.getDecoder().decode(str.getBytes(WorkflowUser.pPPppp("C PY.")));
      Cipher a1;
      (a1 = Cipher.getInstance(JxudpCacheConfig.pPPppp("QFB"))).init(2, getKeyPair(springSecurity).getPrivate());
      return new String(a1.doFinal(a));
   }

   public static String decodeValue(SpringSecurity springSecurity, String value) {
      if(value.startsWith(springSecurity.getEncriptType().toString())) {
         int a = springSecurity.getEncriptType().toString().length();
         if(springSecurity.getEncriptType() == EncriptType.aes) {
            try {
               return new String(springSecurity.getAes().aesDecryptToBytes(value.substring(a)), "utf-8");
            } catch (Exception var4) {
               throw new AuthenticationServiceException(JxudpCacheConfig.pPPppp("剘右伵杦皑叁敥劣寓锚诺＂"), var4);
            }
         }

         if(springSecurity.getEncriptType() == EncriptType.rsa) {
            try {
               return decryptRsa(value.substring(a), (SpringSecurity)springSecurity);
            } catch (Exception var5) {
               throw new AuthenticationServiceException(WorkflowUser.pPPppp("刹另佔杳盰叔攄劶宲锏讛７"), var5);
            }
         }
      }

      return value;
   }

   public static KeyPair getKeyPair(SpringSecurity springSecurity) {
      if(keyPair == null) {
         keyPair = CipherTool.getKeyPair(springSecurity.getKeyPairAlias(), springSecurity.getJkspassword(), springSecurity.getKeystoreFile());
      }

      return keyPair;
   }

   public static void main(String[] args) throws Exception {
      System.out.println("");
      String a = WorkflowUser.pPPppp("9_=T=|5X6q\u001fg\u001c}\u001dQMaDT5G1P5W;U5GLW9_=T7q?U5G1W\u001aQ\u00049%#\u0018~DFLx$ZF\'\u001b[9d\u0000$&d\u001fBMW##\u001eq-a8p\'C\u001a\\\"uMQBc&%\u0017N&D0U\u001e^\u0005A!##O\u0003\u007f\u0002u2\'L&5 7A\u00049\u001dd\u0011G2P6X\u001ba\u0013uAN\u0015WD}$f\u000eS\u0000q\u0007WAO\u0007X,!\u001dE\u001aC\u001dt6&D\"\u001dT p!/\u001cLFD\u0016e\u0017.\u0017A\u0005o\u001aBDD\rX@B$\'&O\"E\u0011@?`9G\u001f\"3BEdC\\7S7= X\u0001\'1Z\u0019t:a9G\rl?|\u0007p6N\r_;U2C[SM\"\u001fb\u0002e L!^2\";g@\"0T\rz7R\u0007EE}C9\u0007p.UFQAS!!;lD{\u001cQL=!lB[\'S%^\u0000y=\u007fB{\u0017.\u0001 @D\u0003\u007fGLGb\u0007u\u0001A3$\'~\u0000e!P\u0001X\'W2X\u001fOCZ\u001fZ\u001a=[~\fZ7cFt:_\'[\u0015S\'wLr3$FU=[\u0001_\u0011D8@\u0017W\u0019S#S#^AS1p\u001bd q_G=R5G5T");
      String a1 = JxudpCacheConfig.pPPppp("2\'0!6");
      SpringSecurity a2 = new SpringSecurity();
      String a3;
      String a4 = decryptRsa(a3 = encryptRsa(a1, a), (SpringSecurity)a2);
      Logger var10000 = log;
      String var10001 = WorkflowUser.pPPppp("\u001bd\u001d6\u000fkXs\u001au\u001br\u0011rTm\t:\u0010s\u0017y\u0010s\u00106\u000fk");
      Object[] var10002 = new Object[3];
      boolean var10004 = true;
      ((Object[])true)[0] = (boolean)a1;
      ((Object[])true)[1] = (boolean)a3;
      ((Object[])true)[2] = (boolean)a4;
      var10001.info(var10002, true);
   }

   public static String encryptRsa(String str, String publicKey) throws Exception {
      byte[] a = Base64.getDecoder().decode(publicKey.getBytes("utf-8"));
      RSAPublicKey a1 = (RSAPublicKey)KeyFactory.getInstance(JxudpCacheConfig.pPPppp("QFB")).generatePublic(new X509EncodedKeySpec(a));
      Cipher a2;
      (a2 = Cipher.getInstance(WorkflowUser.pPPppp("D\'W"))).init(1, a1);
      return Base64.getEncoder().encodeToString(a2.doFinal(str.getBytes(JxudpCacheConfig.pPPppp("VAE8;"))));
   }

   public static String obtainUsername(SpringSecurity springSecurity, String userName) {
      return decodeValue(springSecurity, userName);
   }

   public static String decryptRsa(String str, RSAPrivateKey privateKey) throws Exception {
      byte[] a = Base64.getDecoder().decode(str.getBytes(WorkflowUser.pPPppp("C PY.")));
      Cipher a1;
      (a1 = Cipher.getInstance(JxudpCacheConfig.pPPppp("QFB"))).init(2, privateKey);
      return new String(a1.doFinal(a));
   }

   public static void checkForceEncode(SpringSecurity springSecurity, String password) {
      if(springSecurity.isForceEncode() && !password.startsWith(springSecurity.getEncriptType().toString())) {
         throw new AuthenticationServiceException(WorkflowUser.pPPppp("刹另佔杳盰寐硵霖觵弬剂劶宲７"));
      }
   }

   public static String obtainPassword(SpringSecurity springSecurity, String password) {
      checkForceEncode(springSecurity, password);
      return decodeValue(springSecurity, password);
   }
}
